//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  RoyalBlue
#property indicator_color3  Red
#property indicator_color4  RoyalBlue
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int  MaPeriod        = 6;
extern int  MaMethod        = MODE_SMMA;
extern int  MaPeriod2       = 2;
extern int  MaMethod2       = MODE_LWMA;
extern bool AlertsOn        = false;
extern bool AlertsOnCurrent = true;
extern bool AlertsMessage   = true;
extern bool AlertsOnBody    = true;
extern bool AlertsOnWick    = false;
extern bool AlertsSound     = false;
extern string  AlertSoundfile = "Alert.wav";
extern bool AlertsEmail     = false;
extern bool AlertsNotify    = false;



//
//
//
//
//

double ha1u[];
double ha1d[];
double ha2u[];
double ha2d[];
double ha3u[];
double ha3d[];
double ha4u[];
double ha4d[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,ha1u); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ha1d); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ha2u); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ha2d); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ha3u);
   SetIndexBuffer(5,ha3d);
   SetIndexBuffer(6,ha4u);
   SetIndexBuffer(7,ha4d);
  
   return(0);
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _body 0
#define _wick 1

int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
   //
   //
   //
   //
   //
    
   for (i=limit; i>=0; i--)
   {
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_OPEN ,i);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_CLOSE,i);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW  ,i);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH ,i);
      double haOpen  = (ha3u[i+1]+ha3d[i+1])/2.0;
      double haClose = (maOpen+maHigh+maLow+maClose)/4;
      double haHigh  = MathMax(maHigh, MathMax(haOpen, haClose));
      double haLow   = MathMin(maLow,  MathMin(haOpen, haClose));

      if (haOpen<haClose) 
            { ha4u[i]=haLow; ha4d[i]=haHigh; } 
      else  { ha4d[i]=haLow; ha4u[i]=haHigh; } 
              ha3u[i]=haOpen;
              ha3d[i]=haClose;
   }
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      ha1u[i]=iMAOnArray(ha4u,0,MaPeriod2,0,MaMethod2,i);
      ha1d[i]=iMAOnArray(ha4d,0,MaPeriod2,0,MaMethod2,i);
      ha2u[i]=iMAOnArray(ha3u,0,MaPeriod2,0,MaMethod2,i);
      ha2d[i]=iMAOnArray(ha3d,0,MaPeriod2,0,MaMethod2,i);
         trend[r][_body] = trend[r-1][_body];
         trend[r][_wick] = trend[r-1][_body];
            if (ha1u[i]>ha1d[i]) trend[r][_wick] = -1;
            if (ha1u[i]<ha1d[i]) trend[r][_wick] =  1;
            if (ha2u[i]>ha2d[i]) trend[r][_body] = -1;
            if (ha2u[i]<ha2d[i]) trend[r][_body] =  1;
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
      
      if (trend[whichBar][_body] != trend[whichBar-1][_body] && AlertsOnBody)
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar][_body] ==  1) doAlert(time1,mess1," HA body trend changed to up");
            if (trend[whichBar][_body] == -1) doAlert(time1,mess1," HA body trend changed to down");
      }
      if (MaPeriod2>1 && trend[whichBar][_wick] != trend[whichBar-1][_wick] && AlertsOnWick)
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (trend[whichBar][_wick] ==  1) doAlert(time2,mess2," HA wick trend changed to up");
            if (trend[whichBar][_wick] == -1) doAlert(time2,mess2," HA wick trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" Heiken ashi smoothed",message);
          if (AlertsSound)   PlaySound(AlertSoundfile);
          if (AlertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Heiken ashi smoothed " +" "+message));
   }
}